SystemOrganization addCategory: #'Aeropuerto-Logic'!

Object subclass: #AsientoDeAvion
	instanceVariableNames: 'estado persona numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!AsientoDeAvion class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/8/2012 01:02'!
newNumero: unNumero
	|asiento|
	asiento := super new.
	asiento numero: unNumero.
	asiento estado: 'Libre'.
	^asiento.! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
< unAsiento
	^(self numero < unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
<= unAsiento
	^(self numero <= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
= unAsiento
	^(self numero = unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
> unAsiento
	^(self numero > unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:23'!
>= unAsiento
	^(self numero >= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/8/2012 01:07'!
asignarPersona: unaPersona
	((self estado = 'Reservado') | (self estado = 'Confirmado'))
		ifTrue: [ "Lansar excepcion" self error: 'El asiento ya esta asignado' ]
		ifFalse: [ 
				self estado:  'Reservado'.
				self persona: unaPersona.
			 ]
! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado
	^ estado! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado: anObject
	estado := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:07'!
initialize 
	self estado: 'libre'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:07'!
numero
	^ numero! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:07'!
numero: anObject
	numero := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona
	^ persona! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona: anObject
	persona := anObject! !

!AsientoDeAvion methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 01:09'!
printOn: aStream
	(self estado = 'Libre')
		ifTrue: [ aStream nextPutAll: 'Asiento numero ', self numero asString , ' libre.']
		ifFalse: [
			
			aStream nextPutAll: 'Asiento numero ', self numero asString ,
								' de: ' , self persona nombre, ' ' ,self estado
				].
	! !

Object subclass: #Avion
	instanceVariableNames: 'nombre asientos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Avion class methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:38'!
newNombre: unNombre 
	|avion|
	avion := super new.
	avion nombre: unNombre.
	avion asientos: SortedCollection new.
	1 to: (avion cantidadDeAsientos) do: [ :numero | avion asientos add: (AsientoDeAvion newNumero: numero) ].
	^avion! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
asientos
	^ asientos! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
asientos: anObject
	asientos := anObject! !

!Avion methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:36'!
cantidadDeAsientos 
	self subclassResponsibility.! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre
	^ nombre! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre: anObject
	nombre := anObject! !

!Avion methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 01:13'!
printOn: aStream
	aStream nextPutAll: 'Avion ', self nombre , ' de ', self asientos size asString ,' asientos'.! !

!Avion methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	self subclassResponsibility.! !

Avion subclass: #Comercial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Comercial methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:34'!
cantidadDeAsientos
	^200.! !

!Comercial methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	^800.! !

Avion subclass: #Jet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Jet methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:34'!
cantidadDeAsientos
	^60.! !

!Jet methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:27'!
velocidadPromedio
	^1200.! !

Object subclass: #Pasaje
	instanceVariableNames: 'vuelo persona fReserva nroAsiento'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Pasaje subclass: #Busiess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Pasaje subclass: #Economica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 01:12'!
coeficienteDeCosto: dias
	| dias1 coef res|
	dias1 := dias.
	coef := 1.
	res := 1.
	[dias1 > (30* coef)] whileTrue: [ res := res+(0.5). coef := coef +1. dias1 := dias1 - (30*coef)].
	^res.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:12'!
costo
	self subclassResponsibility.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva
	^ fReserva! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva: anObject
	fReserva := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento
	^ nroAsiento! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento: anObject
	nroAsiento := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona
	^ persona! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona: anObject
	persona := anObject! !

!Pasaje methodsFor: 'print' stamp: 'LeandroGomez 6/8/2012 00:56'!
printOn: aStream
	"Terminar el printOn: "
	aStream nextPutAll:  'Pasaje de: ',self persona printString .! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo
	^ vuelo! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo: anObject
	vuelo := anObject! !

Pasaje subclass: #Primera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Object subclass: #Persona
	instanceVariableNames: 'nombre apellido fnacimiento nacionalidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Persona class methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:45'!
newNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	|persona|
	persona := super new.
	persona nombre: unNombre;
			apellido: unApellido;
			fnacimiento: unaFecha;
			nacionalidad: unaNacionalidad.
	^persona.! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido
	^ apellido! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido: anObject
	apellido := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento
	^ fnacimiento! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento: anObject
	fnacimiento := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad
	^ nacionalidad! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad: anObject
	nacionalidad := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre: anObject
	nombre := anObject! !

Object subclass: #SistemaDeReservas
	instanceVariableNames: 'pasajes vuelos personas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes
	^ pasajes! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes: anObject
	pasajes := anObject! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas
	^ personas! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas: anObject
	personas := anObject! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos
	^ vuelos! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos: anObject
	vuelos := anObject! !

Object subclass: #Vuelo
	instanceVariableNames: 'origen destino avion fechaSalida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Vuelo subclass: #Internacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Internacional methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:32'!
distaciaPromedio
	^4000.! !

Vuelo subclass: #Transbordo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Transbordo methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:32'!
distaciaPromedio
	^1000.! !

!Vuelo class methodsFor: 'as yet unclassified' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:02'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha
	"unaFecha debe ser un string de la forma <nroDia> <mesEnString> <nroAo>"
	|vuelo|
	vuelo := super new.
	vuelo origen: unOrigen;
		   destino: unDestino;
		   avion: unAvion;
		   fechaSalida: unaFecha asDate.
	^vuelo
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion
	^ avion! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion: anObject
	avion := anObject! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino
	^ destino! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino: anObject
	destino := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:31'!
distaciaPromedio
	self subclassResponsibility.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:33'!
duracion
	^ self distaciaPromedio / self avion velocidadPromedio.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:49'!
fechaSalida
		^ fechaSalida
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:46'!
fechaSalida: anObject
	fechaSalida := anObject! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen
	^ origen! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen: anObject
	origen := anObject! !

!Vuelo methodsFor: 'printing' stamp: 'LeandroGomez 6/8/2012 01:14'!
printOn: aStream
	"Definir el stream"! !
